<head><link rel="stylesheet" href="https:\/\/distrotube.com/css/style.css">
<title># It's Time For a New Text Editor</title>
<pre>
                          __       _______ _______ _______ ___ _______ ___     _______ _______
 .-----.--.--.-----.-----|  |_    |   _   |   _   |       |   |   _   |   |   |   _   |   _   |
 |  _  |  |  |  -__|__ --|   _|   |.  1   |.  l   |.|   | |.  |.  1___|.  |   |.  1___|   1___|
 |___  |_____|_____|_____|____|   |.  _   |.  _   `-|.  |-|.  |.  |___|.  |___|.  __)_|____   |
 |_____|                          |:  |   |:  |   | |:  | |:  |:  1   |:  1   |:  1   |:  1   |
                                  |::.|:. |::.|:. | |::.| |::.|::.. . |::.. . |::.. . |::.. . |
                                  `--- ---`--- ---&#39 `---&#39 `---`-------`-------`-------`-------&#39
</pre>
<p><br/></p>
<h1>It&#39s Time For a New Text Editor</h1>
<p>By Klaus-Dieter Schmatz at March 20, 2020</p>
<p><br/></p>
<p>Let&#39s be honest. Vim is bloated. Sure, it&#39s a great, feature-rich editor with an impressive ecosystem of plugins. Unfortunately, not only that. Vim is also a mediocre file and directory browser, a lacklustre spell checker, a poor window manager, and other things. Sure, Vim is way more focused on editing text than Emacs, but that&#39s true for any editor.</p>
<p><br/></p>
<h2>sudo pacman -Rs vim</h2>
<p>During its 28 years of active development, Vim has accumulated a lot of technical debt and redundant functionality that should better have been implemented separately. The verdict: Vim is guilty of violating one of the cornerstones of the UNIX philosophy: Write programs that do one thing and do it well. The sentence: sudo pacman -Rs vim.</p>
<p><br/></p>
<p>In fact, I gave up Vim in favor of Neovim quite some time ago. The Neovim project maintains compatibility with Vim while trying to improve the codebase. Indeed, instead of Vim&#39s 300K lines of code, Neovim weighs in at comparatively modest 175K. Still huge though, and with tons of irrelevant features.</p>
<p><br/></p>
<h2>What&#39s the Alternative?</h2>
<p>Turn to stuff that rocks on suckless.org:</p>
<p><br/></p>
<pre>
vis - A modern, legacy free, simple yet efficient vim-like editor.
</pre>
<p><br/></p>
<p>Vis is not compatible with Vim by design, but it uses the same keybindings for the most part. It does not come with the same feature set and you can&#39t use plugins written in Vimscript. Extensions can be implemented in Lua, arguably a much better language than Vimscript. And there are cool text editing features such as structural regular expressions (which can span lines) and multiple cursors/selections, which are not available in Vim.</p>
<p><br/></p>
<h2>Get Started</h2>
<p>After installing Vis with your favorite package manager, set up your init script in ~/.config/vis/visrc.lua. I like to keep things simple, so mine is quite short:</p>
<p><br/></p>
<pre>
require(&#39vis&#39)
require(&#39plugins/vis-modelines&#39)
require(&#39plugins/vis-commentary&#39)
require(&#39plugins/vis-filetype-settings&#39)

settings = {
    java = { &#39set autoindent&#39, &#39set expandtab&#39, &#39set tabwidth 4&#39 },
    yaml = { &#39set autoindent&#39, &#39set expandtab&#39, &#39set tabwidth 2&#39 }
}

vis.events.subscribe(vis.events.INIT, function()
    vis:command(&#39set theme gruvbox&#39)
end)

vis.events.subscribe(vis.events.WIN_OPEN, function(win)
    vis:command(&#39set relativenumbers&#39)
    vis:command(&#39set cursorline&#39)
end)
</pre>
<p><br/></p>
<p>Plugins are available from the links below:</p>
<a style="display: block;" href="https://github.com/martanne/vis/wiki/Plugins">https://github.com/martanne/vis/wiki/Plugins</a>
<a style="display: block;" href="https://github.com/martanne/vis/wiki/Themes">https://github.com/martanne/vis/wiki/Themes</a>
<p><br/></p>
<p>My plugins and themes are installed in ~/.config/vis:</p>
<p><br/></p>
<pre>
  vis
├──   plugins
│  ├──   vis-commentary.lua
│  ├──   vis-filetype-settings.lua
│  └──   vis-modelines.lua
├──   themes
│  └──   gruvbox.lua
└──   visrc.lua
</pre>
<p><br/></p>
<h2>Not For Everybody</h2>
<p>If you really like netrw or rely on dozens of Vim plugins, Vis is not for you. If on the other hand all you want is a simple yet efficient editor with Vim keybindings, you may appreciate Vis.</p>
